Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# ACE_Asynch_Accept Class Reference

This class is a factory for starting off asynchronous accepts on a listen handle. This class forwards all methods to its implementation class. More...

`#include <Asynch_IO.h>`

Inheritance diagram for ACE_Asynch_Accept:

[legend]
Collaboration diagram for ACE_Asynch_Accept:

[legend]
List of all members.

## Public Methods
| ACE_Asynch_Accept (void)
| A do nothing constructor. More...
virtual | ~ACE_Asynch_Accept (void)
| Destructor. More...
int | open (ACE_Handler &handler, ACE_HANDLE handle=ACE_INVALID_HANDLE, const void *completion_key=0, ACE_Proactor *proactor=0)
| Initializes the factory with information which will be used with each asynchronous call. More...
int | accept (ACE_Message_Block &message_block, size_t bytes_to_read, ACE_HANDLE accept_handle=ACE_INVALID_HANDLE, const void *act=0, int priority=0, int signal_number=ACE_SIGRTMIN)
| This starts off an asynchronous accept. More...
ACE_Asynch_Accept_Impl * | implementation (void) const
| Return the underlying implementation class. More...
## Protected Methods
void | implementation (ACE_Asynch_Accept_Impl *implementation)
| Set the implementation class. More...
## Protected Attributes
ACE_Asynch_Accept_Impl * | implementation_
| Delegation/implementation class that all methods will be forwarded to. More...

## Detailed Description

This class is a factory for starting off asynchronous accepts on a listen handle. This class forwards all methods to its implementation class.

Once <open> is called, multiple asynchronous <accept>s can started using this class. A ACE_Asynch_Accept::Result will be passed back to the <handler> when the asynchronous accept completes through the <ACE_Handler::handle_accept> callback.

## Constructor & Destructor Documentation

ACE_Asynch_Accept::ACE_Asynch_Accept | ( | void |  | ) |

| A do nothing constructor.

ACE_Asynch_Accept::~ACE_Asynch_Accept | ( | void |  | ) | `[virtual]`

| Destructor.

## Member Function Documentation

int ACE_Asynch_Accept::accept | ( | ACE_Message_Block & | message_block,
|  | size_t | bytes_to_read,
|  | ACE_HANDLE | accept_handle = ACE_INVALID_HANDLE,
|  | const void * | act = 0,
|  | int | priority = 0,
|  | int | signal_number = ACE_SIGRTMIN
| ) |

| This starts off an asynchronous accept. The asynchronous accept call also allows any initial data to be returned to the <handler>. Upto <bytes_to_read> will be read and stored in the <message_block>. The <accept_handle> will be used for the <accept> call. If (<accept_handle> == INVALID_HANDLE), a new handle will be created. Priority of the operation is specified by <priority>. On POSIX4-Unix, this is supported. Works like <nice> in Unix. Negative values are not allowed. 0 means priority of the operation same as the process priority. 1 means priority of the operation is one less than process. And so forth. On Win32, this is a no-op. <message_block> must be specified. This is because the address of the new connection is placed at the end of this buffer. <signal_number> is the POSIX4 real-time signal number to be used for the operation. <signal_number> ranges from ACE_SIGRTMIN to ACE_SIGRTMAX. This argument is a no-op on non-POSIX4 systems.

void ACE_Asynch_Accept::implementation | ( | ACE_Asynch_Accept_Impl * | implementation | ) | `[protected]`

| Set the implementation class.

ACE_Asynch_Accept_Impl * ACE_Asynch_Accept::implementation | ( | void |  | ) | const

| Return the underlying implementation class. Reimplemented from ACE_Asynch_Operation.

int ACE_Asynch_Accept::open | ( | ACE_Handler & | handler,
|  | ACE_HANDLE | handle = ACE_INVALID_HANDLE,
|  | const void * | completion_key = 0,
|  | ACE_Proactor * | proactor = 0
| ) |

| Initializes the factory with information which will be used with each asynchronous call. If (<handle> == ACE_INVALID_HANDLE), <ACE_Handler::handle> will be called on the <handler> to get the correct handle. Reimplemented from ACE_Asynch_Operation.

## Member Data Documentation

ACE_Asynch_Accept_Impl* ACE_Asynch_Accept::implementation_`[protected]`

| Delegation/implementation class that all methods will be forwarded to. Reimplemented from ACE_Asynch_Operation.

The documentation for this class was generated from the following files:

- Asynch_IO.h
- Asynch_IO.cpp